diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/tcp-hybla-test.cc ns-3.38/src/internet/test/tcp-hybla-test.cc
--- ns-3.37/src/internet/test/tcp-hybla-test.cc	2022-11-01 17:37:24.511395200 -0700
+++ ns-3.38/src/internet/test/tcp-hybla-test.cc	2023-03-16 20:54:23.628868600 -0700
@@ -28,7 +28,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief Testing the congestion avoidance increment on TcpHybla
  */
@@ -149,7 +148,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief TCP Hybla TestSuite
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/tcp-illinois-test.cc ns-3.38/src/internet/test/tcp-illinois-test.cc
--- ns-3.37/src/internet/test/tcp-illinois-test.cc	2022-11-01 17:37:24.511395200 -0700
+++ ns-3.38/src/internet/test/tcp-illinois-test.cc	2023-03-16 20:54:23.628868600 -0700
@@ -35,7 +35,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief TcpIllinois C-AIMD algorithm tests.
  */
@@ -346,7 +345,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief TCP Illinois TestSuite
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/tcp-ledbat-test.cc ns-3.38/src/internet/test/tcp-ledbat-test.cc
--- ns-3.37/src/internet/test/tcp-ledbat-test.cc	2022-11-01 17:37:24.511395200 -0700
+++ ns-3.38/src/internet/test/tcp-ledbat-test.cc	2023-03-16 20:54:23.628868600 -0700
@@ -31,7 +31,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief LEDBAT should be same as NewReno during slow start, and when timestamps are disabled
  */
@@ -132,7 +131,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief Test to validate cWnd increment in LEDBAT
  */
@@ -234,7 +232,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief Test to validate cWnd decrement in LEDBAT
  */
@@ -339,7 +336,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief TCP Ledbat TestSuite
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/tcp-linux-reno-test.cc ns-3.38/src/internet/test/tcp-linux-reno-test.cc
--- ns-3.37/src/internet/test/tcp-linux-reno-test.cc	2022-11-01 17:37:24.511395200 -0700
+++ ns-3.38/src/internet/test/tcp-linux-reno-test.cc	2023-03-16 20:54:23.628868600 -0700
@@ -31,7 +31,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * This unit test checks that the slow start and congestion avoidance
  * behavior matches Linux behavior as follows:
@@ -195,7 +194,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * This unit test checks that the slow start and congestion avoidance
  * behavior matches Linux behavior as follows:
@@ -372,7 +370,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief TestSuite for the behavior of Linux Reno
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/tcp-loss-test.cc ns-3.38/src/internet/test/tcp-loss-test.cc
--- ns-3.37/src/internet/test/tcp-loss-test.cc	2022-11-01 17:37:24.511395200 -0700
+++ ns-3.38/src/internet/test/tcp-loss-test.cc	2023-03-16 20:54:23.628868600 -0700
@@ -28,7 +28,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief Check rollover of sequence number and how that affects loss recovery
  *
@@ -176,7 +175,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * Test various packet losses
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/tcp-lp-test.cc ns-3.38/src/internet/test/tcp-lp-test.cc
--- ns-3.37/src/internet/test/tcp-lp-test.cc	2022-11-01 17:37:24.511395200 -0700
+++ ns-3.38/src/internet/test/tcp-lp-test.cc	2023-03-16 20:54:23.628868600 -0700
@@ -33,7 +33,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief Testing the behaviour common to New Reno
  */
@@ -114,7 +113,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief Testing TcpLp when cwd exceeds threshold
  */
@@ -184,7 +182,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief Testing TcpLp when it is inference phase
  */
@@ -258,7 +255,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * Test the behaviour common to New Reno
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/tcp-option-test.cc ns-3.38/src/internet/test/tcp-option-test.cc
--- ns-3.37/src/internet/test/tcp-option-test.cc	2022-11-01 17:37:24.511395200 -0700
+++ ns-3.38/src/internet/test/tcp-option-test.cc	2023-03-16 20:54:23.628868600 -0700
@@ -28,7 +28,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief TCP Window Scaling option Test
  */
@@ -107,7 +106,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief TCP TimeStamp option Test
  */
@@ -198,7 +196,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief TCP options TestSuite
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/tcp-pacing-test.cc ns-3.38/src/internet/test/tcp-pacing-test.cc
--- ns-3.37/src/internet/test/tcp-pacing-test.cc	2022-11-01 17:37:24.511395200 -0700
+++ ns-3.38/src/internet/test/tcp-pacing-test.cc	2023-03-16 20:54:23.628868600 -0700
@@ -30,7 +30,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief Test the behavior of TCP pacing
  *
@@ -373,7 +372,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief TestSuite for the behavior of TCP pacing
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/tcp-pkts-acked-test.cc ns-3.38/src/internet/test/tcp-pkts-acked-test.cc
--- ns-3.37/src/internet/test/tcp-pkts-acked-test.cc	2022-11-01 17:37:24.511395200 -0700
+++ ns-3.38/src/internet/test/tcp-pkts-acked-test.cc	2023-03-16 20:54:23.628868600 -0700
@@ -30,7 +30,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief Check the number of times that PktsAcked is called
  *
@@ -76,7 +75,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief Behaves as NewReno, except that each time PktsAcked is called,
  * a notification is sent to TcpPktsAckedOpenTest.
@@ -173,7 +171,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief PktsAcked is calls TestSuite.
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/tcp-prr-recovery-test.cc ns-3.38/src/internet/test/tcp-prr-recovery-test.cc
--- ns-3.37/src/internet/test/tcp-prr-recovery-test.cc	2022-11-01 17:37:24.511395200 -0700
+++ ns-3.38/src/internet/test/tcp-prr-recovery-test.cc	2023-03-16 20:54:23.628868600 -0700
@@ -145,7 +145,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief PRR Recovery TestSuite
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/tcp-rate-ops-test.cc ns-3.38/src/internet/test/tcp-rate-ops-test.cc
--- ns-3.37/src/internet/test/tcp-rate-ops-test.cc	2022-11-01 17:37:24.511395200 -0700
+++ ns-3.38/src/internet/test/tcp-rate-ops-test.cc	2023-03-16 20:54:23.628868600 -0700
@@ -184,7 +184,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief Behaves as NewReno except HasCongControl returns true
  */
@@ -439,7 +438,7 @@
  * \ingroup internet-tests
  * \ingroup tests
  *
- * \brief The TcpRateLinuxWithBufferTest tests rate sample functionality with arbitary SACK
+ * \brief The TcpRateLinuxWithBufferTest tests rate sample functionality with arbitrary SACK
  * scenario. Check the value of delivered against a home-made guess
  */
 class TcpRateLinuxWithBufferTest : public TestCase
@@ -471,7 +470,7 @@
     /** \brief Test with acks without drop */
     void TestWithStraightAcks();
 
-    /** \brief Test with arbitary SACK scenario */
+    /** \brief Test with arbitrary SACK scenario */
     void TestWithSackBlocks();
 
     uint32_t m_expectedDelivered{0};   //!< Amount of expected delivered data
@@ -595,7 +594,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief the TestSuite for the TcpRateLinux test case
  */
@@ -647,12 +645,12 @@
 
         AddTestCase(
             new TcpRateLinuxWithBufferTest(1000,
-                                           "Checking rate sample values with arbitary SACK Block"),
+                                           "Checking rate sample values with arbitrary SACK Block"),
             TestCase::QUICK);
 
         AddTestCase(
             new TcpRateLinuxWithBufferTest(500,
-                                           "Checking rate sample values with arbitary SACK Block"),
+                                           "Checking rate sample values with arbitrary SACK Block"),
             TestCase::QUICK);
     }
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/tcp-rto-test.cc ns-3.38/src/internet/test/tcp-rto-test.cc
--- ns-3.37/src/internet/test/tcp-rto-test.cc	2022-11-01 17:37:24.511395200 -0700
+++ ns-3.38/src/internet/test/tcp-rto-test.cc	2023-03-16 20:54:23.628868600 -0700
@@ -30,7 +30,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief Testing the moments after an RTO expiration
  *
@@ -107,7 +106,7 @@
     // This function is called after the management of the RTO expiration,
     // and because of this we must check all the involved variables.
     NS_TEST_ASSERT_MSG_EQ(m_afterRTOExpired, false, "Second RTO expired");
-    NS_TEST_ASSERT_MSG_EQ(GetCongStateFrom(tcb),
+    NS_TEST_ASSERT_MSG_EQ(tcb->m_congState.Get(),
                           TcpSocketState::CA_LOSS,
                           "Ack state machine not in LOSS state after a loss");
 
@@ -125,13 +124,13 @@
 
     if (m_afterRTOExpired && who == SENDER)
     {
-        NS_TEST_ASSERT_MSG_EQ(GetCongStateFrom(tcb),
+        NS_TEST_ASSERT_MSG_EQ(tcb->m_congState.Get(),
                               TcpSocketState::CA_LOSS,
                               "Ack state machine not in LOSS state after a loss");
     }
     else
     {
-        NS_TEST_ASSERT_MSG_EQ(GetCongStateFrom(tcb),
+        NS_TEST_ASSERT_MSG_EQ(tcb->m_congState.Get(),
                               TcpSocketState::CA_OPEN,
                               "Ack state machine not in OPEN state after recovering "
                               "from loss");
@@ -144,7 +143,7 @@
     // Called after the ACK processing. Every time we should be in OPEN state,
     // without any packet lost or marked as retransmitted, in both the sockets
 
-    NS_TEST_ASSERT_MSG_EQ(GetCongStateFrom(tcb),
+    NS_TEST_ASSERT_MSG_EQ(tcb->m_congState.Get(),
                           TcpSocketState::CA_OPEN,
                           "Ack state machine not in OPEN state after recovering "
                           "from loss");
@@ -167,7 +166,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief Testing the ssthresh behavior after the RTO expires
  *
@@ -314,7 +312,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief Testing the timing of RTO
  *
@@ -510,7 +507,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief TCP RTO TestSuite
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/tcp-rtt-estimation.cc ns-3.38/src/internet/test/tcp-rtt-estimation.cc
--- ns-3.37/src/internet/test/tcp-rtt-estimation.cc	2022-11-01 17:37:24.511395200 -0700
+++ ns-3.38/src/internet/test/tcp-rtt-estimation.cc	2023-03-16 20:54:23.628868600 -0700
@@ -29,7 +29,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief Check Rtt calculations
  *
@@ -192,7 +191,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief Check Rtt calculations with packet losses.
  *
@@ -246,7 +244,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief TCP RTT estimation TestSuite
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/tcp-rx-buffer-test.cc ns-3.38/src/internet/test/tcp-rx-buffer-test.cc
--- ns-3.37/src/internet/test/tcp-rx-buffer-test.cc	2022-11-01 17:37:24.511395200 -0700
+++ ns-3.38/src/internet/test/tcp-rx-buffer-test.cc	2023-03-16 20:54:23.628868600 -0700
@@ -296,7 +296,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief the TestSuite for the TcpRxBuffer test case
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/tcp-sack-permitted-test.cc ns-3.38/src/internet/test/tcp-sack-permitted-test.cc
--- ns-3.37/src/internet/test/tcp-sack-permitted-test.cc	2022-11-01 17:37:24.511395200 -0700
+++ ns-3.38/src/internet/test/tcp-sack-permitted-test.cc	2023-03-16 20:54:23.628868600 -0700
@@ -29,7 +29,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief Test case for checking the SACK-PERMITTED option.
  *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/tcp-scalable-test.cc ns-3.38/src/internet/test/tcp-scalable-test.cc
--- ns-3.37/src/internet/test/tcp-scalable-test.cc	2022-11-01 17:37:24.511395200 -0700
+++ ns-3.38/src/internet/test/tcp-scalable-test.cc	2023-03-16 20:54:23.628868600 -0700
@@ -36,7 +36,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief Testing the congestion avoidance increment on TcpScalable
  */
@@ -106,7 +105,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief Testing the multiplicative decrease on TcpScalable
  */
@@ -165,7 +163,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief TcpScalable TestSuite.
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/tcp-slow-start-test.cc ns-3.38/src/internet/test/tcp-slow-start-test.cc
--- ns-3.37/src/internet/test/tcp-slow-start-test.cc	2022-11-01 17:37:24.511395200 -0700
+++ ns-3.38/src/internet/test/tcp-slow-start-test.cc	2023-03-16 20:54:23.628868600 -0700
@@ -30,7 +30,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief Test the normal behavior for slow start
  *
@@ -208,7 +207,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief A slow start test using a socket which sends smaller ACKs
  *
@@ -262,7 +260,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief TCP Slow Start TestSuite.
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/tcp-syn-connection-failed-test.cc ns-3.38/src/internet/test/tcp-syn-connection-failed-test.cc
--- ns-3.37/src/internet/test/tcp-syn-connection-failed-test.cc	2022-11-01 17:37:24.511395200 -0700
+++ ns-3.38/src/internet/test/tcp-syn-connection-failed-test.cc	2023-03-16 20:54:23.628868600 -0700
@@ -27,7 +27,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief Test that connection failed callback is called when
  * SYN retransmission number is exceeded.
@@ -96,7 +95,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief TestSuite
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/tcp-test.cc ns-3.38/src/internet/test/tcp-test.cc
--- ns-3.37/src/internet/test/tcp-test.cc	2022-11-01 17:37:24.511395200 -0700
+++ ns-3.38/src/internet/test/tcp-test.cc	2023-03-16 20:54:23.628868600 -0700
@@ -52,7 +52,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief TCP Test - send string data from client to server and back.
  */
@@ -537,7 +536,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief TCP TestSuite - send string data from client to server and back.
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/tcp-timestamp-test.cc ns-3.38/src/internet/test/tcp-timestamp-test.cc
--- ns-3.37/src/internet/test/tcp-timestamp-test.cc	2022-11-01 17:37:24.511395200 -0700
+++ ns-3.38/src/internet/test/tcp-timestamp-test.cc	2023-03-16 20:54:23.628868600 -0700
@@ -29,7 +29,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief TCP TimeStamp enabling Test.
  */
@@ -210,7 +209,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief TCP TimeStamp values Test.
  */
@@ -291,7 +289,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief TCP TimeStamp TestSuite.
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/tcp-tx-buffer-test.cc ns-3.38/src/internet/test/tcp-tx-buffer-test.cc
--- ns-3.37/src/internet/test/tcp-tx-buffer-test.cc	2022-11-01 17:37:24.511395200 -0700
+++ ns-3.38/src/internet/test/tcp-tx-buffer-test.cc	2023-03-16 20:54:23.628868600 -0700
@@ -432,7 +432,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief the TestSuite for the TcpTxBuffer test case
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/tcp-vegas-test.cc ns-3.38/src/internet/test/tcp-vegas-test.cc
--- ns-3.37/src/internet/test/tcp-vegas-test.cc	2022-11-01 17:37:24.511395200 -0700
+++ ns-3.38/src/internet/test/tcp-vegas-test.cc	2023-03-16 20:54:23.628868600 -0700
@@ -202,7 +202,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief TCP Vegas TestSuite
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/tcp-veno-test.cc ns-3.38/src/internet/test/tcp-veno-test.cc
--- ns-3.37/src/internet/test/tcp-veno-test.cc	2022-11-01 17:37:24.511395200 -0700
+++ ns-3.38/src/internet/test/tcp-veno-test.cc	2023-03-16 20:54:23.628868600 -0700
@@ -35,7 +35,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief Testing the additive increase and multiplicative decrease of TcpVeno
  */
@@ -80,7 +79,7 @@
      */
     uint32_t MultiplicativeDecrease(uint32_t diff,
                                     const UintegerValue& beta,
-                                    uint32_t bytesInFlight);
+                                    uint32_t bytesInFlight) const;
 
     /**
      * \brief Mimics the NewReno IncreaseWindow algorithm.
@@ -244,7 +243,7 @@
 uint32_t
 TcpVenoTest::MultiplicativeDecrease(uint32_t diff,
                                     const UintegerValue& beta,
-                                    uint32_t bytesInFlight)
+                                    uint32_t bytesInFlight) const
 {
     uint32_t calculatedSsThresh;
     if (diff < beta.Get())
@@ -300,7 +299,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief TCP Veno TestSuite
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/tcp-wscaling-test.cc ns-3.38/src/internet/test/tcp-wscaling-test.cc
--- ns-3.37/src/internet/test/tcp-wscaling-test.cc	2022-11-01 17:37:24.511395200 -0700
+++ ns-3.38/src/internet/test/tcp-wscaling-test.cc	2023-03-16 20:54:23.628868600 -0700
@@ -32,7 +32,6 @@
 // TODO: Check the buffer size and scaling option value
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief TCP Window Scaling enabling Test.
  */
@@ -226,7 +225,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief TCP Window Scaling TestSuite.
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/tcp-yeah-test.cc ns-3.38/src/internet/test/tcp-yeah-test.cc
--- ns-3.37/src/internet/test/tcp-yeah-test.cc	2022-11-01 17:37:24.511395200 -0700
+++ ns-3.38/src/internet/test/tcp-yeah-test.cc	2023-03-16 20:54:23.628868600 -0700
@@ -35,7 +35,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief Testing TcpYeah additive increase algorithm.
  */
@@ -216,7 +215,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief Testing TcpYeah multiplicative decrease algorithm
  */
@@ -359,7 +357,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief TCP Yeah TestSuite
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/tcp-zero-window-test.cc ns-3.38/src/internet/test/tcp-zero-window-test.cc
--- ns-3.37/src/internet/test/tcp-zero-window-test.cc	2022-11-01 17:37:24.511395200 -0700
+++ ns-3.38/src/internet/test/tcp-zero-window-test.cc	2023-03-16 20:54:23.632868500 -0700
@@ -28,7 +28,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief Testing the congestion avoidance increment on TCP ZeroWindow
  */
@@ -169,10 +168,10 @@
         }
     }
 
-    NS_TEST_ASSERT_MSG_EQ(GetCongStateFrom(GetTcb(SENDER)),
+    NS_TEST_ASSERT_MSG_EQ(GetTcb(SENDER)->m_congState.Get(),
                           TcpSocketState::CA_OPEN,
                           "Sender State is not OPEN");
-    NS_TEST_ASSERT_MSG_EQ(GetCongStateFrom(GetTcb(RECEIVER)),
+    NS_TEST_ASSERT_MSG_EQ(GetTcb(RECEIVER)->m_congState.Get(),
                           TcpSocketState::CA_OPEN,
                           "Receiver State is not OPEN");
 }
@@ -249,7 +248,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief TCP ZeroWindow TestSuite
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/udp-test.cc ns-3.38/src/internet/test/udp-test.cc
--- ns-3.37/src/internet/test/udp-test.cc	2022-11-01 17:37:24.511395200 -0700
+++ ns-3.38/src/internet/test/udp-test.cc	2023-03-16 20:54:23.632868500 -0700
@@ -57,7 +57,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief UDP Socket Loopback over IPv4 Test
  */
@@ -115,7 +114,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief UDP Socket Loopback over IPv6 Test
  */
@@ -172,7 +170,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief UDP Socket over IPv4 Test
  */
@@ -524,7 +521,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief UDP Socket over IPv6 Test
  */
@@ -768,7 +764,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief UDP TestSuite
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet-apps/CMakeLists.txt ns-3.38/src/internet-apps/CMakeLists.txt
--- ns-3.37/src/internet-apps/CMakeLists.txt	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/internet-apps/CMakeLists.txt	2023-03-16 20:54:23.608868600 -0700
@@ -2,6 +2,7 @@
   LIBNAME internet-apps
   SOURCE_FILES
     helper/dhcp-helper.cc
+    helper/ping-helper.cc
     helper/ping6-helper.cc
     helper/radvd-helper.cc
     helper/v4ping-helper.cc
@@ -9,6 +10,7 @@
     model/dhcp-client.cc
     model/dhcp-header.cc
     model/dhcp-server.cc
+    model/ping.cc
     model/ping6.cc
     model/radvd-interface.cc
     model/radvd-prefix.cc
@@ -17,6 +19,7 @@
     model/v4traceroute.cc
   HEADER_FILES
     helper/dhcp-helper.h
+    helper/ping-helper.h
     helper/ping6-helper.h
     helper/radvd-helper.h
     helper/v4ping-helper.h
@@ -24,6 +27,7 @@
     model/dhcp-client.h
     model/dhcp-header.h
     model/dhcp-server.h
+    model/ping.h
     model/ping6.h
     model/radvd-interface.h
     model/radvd-prefix.h
@@ -31,6 +35,8 @@
     model/v4ping.h
     model/v4traceroute.h
   LIBRARIES_TO_LINK ${libinternet}
-  TEST_SOURCES test/dhcp-test.cc
-               test/ipv6-radvd-test.cc
+  TEST_SOURCES
+    test/dhcp-test.cc
+    test/ipv6-radvd-test.cc
+    test/ping-test.cc
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet-apps/examples/CMakeLists.txt ns-3.38/src/internet-apps/examples/CMakeLists.txt
--- ns-3.37/src/internet-apps/examples/CMakeLists.txt	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/internet-apps/examples/CMakeLists.txt	2023-03-16 20:54:23.608868600 -0700
@@ -21,3 +21,14 @@
     ${libwifi}
     ${libinternet-apps}
 )
+
+build_lib_example(
+  NAME ping-example
+  SOURCE_FILES ping-example.cc
+  LIBRARIES_TO_LINK
+    ${libcore}
+    ${libinternet}
+    ${libinternet-apps}
+    ${libnix-vector-routing}
+    ${libpoint-to-point}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet-apps/examples/dhcp-example.cc ns-3.38/src/internet-apps/examples/dhcp-example.cc
--- ns-3.37/src/internet-apps/examples/dhcp-example.cc	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/internet-apps/examples/dhcp-example.cc	2023-03-16 20:54:23.608868600 -0700
@@ -196,4 +196,6 @@
     Simulator::Run();
     Simulator::Destroy();
     NS_LOG_INFO("Done.");
+
+    return 0;
 }
